﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WriteNotWrite.Pages
{
    /// <summary>
    /// Логика взаимодействия для Authorization.xaml
    /// </summary>
    public partial class Authorization : Page
    {
        public TradeBase DB = new TradeBase();
        bool CapaFlag = false;
        System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();
        string Capcha = "";
        public Authorization()
        {
            InitializeComponent();
        }

        private void GoAuth(object sender, RoutedEventArgs e)
        {
            if(EnteredLogin.Text!=null && EnteredLogin.Text!="" && EnteredPass.Password != null && EnteredPass.Password != "")
            {
                User user = DB.User.Where(x=>x.UserLogin==EnteredLogin.Text && x.UserPassword==EnteredPass.Password).FirstOrDefault();
                if(user!=null && CapaFlag == false)
                {
                    MainFrame.mFrame.Navigate(new UserGuestPage(user.UserID));
                }
                else if (user != null && CapaFlag == true)
                {
                    if (CapaText.Text.ToUpper() == Capcha.ToUpper())
                    {
                        MainFrame.mFrame.Navigate(new UserGuestPage(user.UserID));
                    }
                    else
                    {
                        MessageBox.Show("Текст капчи введён неправильно");
                        AuthUser.IsEnabled = false;
                        AuthGuest.IsEnabled = false;
                        CreateCap();
                        timer.Tick += new EventHandler(timerTick);
                        timer.Interval = new TimeSpan(0, 0, 10);
                        timer.Start();

                    }
                }
                else if(user == null && CapaFlag == true)
                {
                    MessageBox.Show("Вас не существует, либо данные неправильные");
                    AuthUser.IsEnabled = false;
                    AuthGuest.IsEnabled = false;
                    CreateCap();
                    timer.Tick += new EventHandler(timerTick);
                    timer.Interval = new TimeSpan(0, 0, 10);
                    timer.Start();
                }
                else
                {
                    MessageBox.Show("Вас не существует, либо данные неправильные");
                    Capa.Visibility = Visibility.Visible;
                    CreateCap();
                    CapaFlag = true;
                }
            }
            else
            {
                MessageBox.Show("Вы не заполнили одно из полей");
            }
        }

        private void GoGuest(object sender, RoutedEventArgs e)
        {
            MainFrame.mFrame.Navigate(new UserGuestPage());
        }

        private void timerTick(object sender, EventArgs e)
        {
            AuthUser.IsEnabled = true;
            AuthGuest.IsEnabled = true;
        }

        public void CreateCap()
        {
            Capcha = "";
            SolidColorBrush color = new SolidColorBrush(Colors.Yellow);
            Canvas canava = new Canvas()
            {
                Width = 200,
                Height = 200,
                Background = color,
                Margin = new Thickness(0, 10, 0, 0)
            };
            Random r = new Random();
            int fs;
            FontStyle fontStyle = FontStyles.Normal;
            FontWeight fontWeight = FontWeights.Normal;
            for (int i = 1; i <= 10; i++)
            {
                fs = r.Next(1, 3);
                if (fs == 1)
                {
                    fontStyle = FontStyles.Oblique;
                }
                if (fs == 2)
                {
                    fontWeight = FontWeights.Bold;
                }
                if (fs == 3)
                {
                    fontWeight = FontWeights.Bold;
                    fontStyle = FontStyles.Italic;
                }
                TextBlock tb = new TextBlock()
                {
                    Padding = new Thickness(i * 19, r.Next(50,100), 0, r.Next(50,100)),
                    Foreground = new SolidColorBrush(Colors.LimeGreen),
                    FontStyle = fontStyle,
                    FontWeight = fontWeight
                };
                if (i % 2 == 0)
                {
                    tb.Text = Convert.ToString((char)r.Next(65, 90));
                }
                else
                {
                    tb.Text = Convert.ToString(r.Next(1, 9));
                }
                Capcha += tb.Text;
                canava.Children.Add(tb);
                Line line = new Line()
                {
                    X1 = r.Next(200),
                    Y1 = r.Next(200),
                    X2 = r.Next(200),
                    Y2 = r.Next(200),
                    Stroke = Brushes.Red,
                    StrokeThickness = 3
                };
                canava.Children.Add(line);
            }

            CapchaPic.Children.Add(canava);
        }
    }
}
